<template>
  <main>
    <section class="section">
      <h1 class="use-cases-section-title">
        {{ $t('pages.useCases.main_title') }}
      </h1>
      <p class="main-description">
        {{ $t('pages.useCases.main_description') }}
      </p>
      <img
        src="@/assets/images/use-case.png"
        loading="lazy"
        :alt="$t('pages.useCases.alt_main_image')"
        class="img-use-cases"
      />
    </section>
    <section class="section">
      <h2 class="use-cases-section-title">
        {{ $t('pages.useCases.subtitle_use_cases') }}
      </h2>
      <p
        v-html="$t('pages.useCases.desc_use_cases')"
        class="main-description"
      />
      <ul class="use-cases-list">
        <li
          v-for="useCaseArticle in useCasesArticles"
          :key="useCaseArticle.title"
          class="use-case-article-item"
        >
          <router-link
            :to="{
              name: 'useCaseArticleItem',
              params: { id: useCaseArticle.id }
            }"
            class="article-link"
          >
            <UseCaseCard
              :title="useCaseArticle.title"
              :description="useCaseArticle.description"
              :image="useCaseArticle.image"
              look="blue"
            >
              <div slot="image" class="wrapper-icon-article-use-case">
                <img
                  :src="img(useCaseArticle.image.url)"
                  :alt="useCaseArticle.image.alt"
                  loading="lazy"
                  class="icon-use-case"
                />
              </div>
            </UseCaseCard>
          </router-link>
        </li>
      </ul>
    </section>
    <section class="section">
      <h2 class="use-cases-section-title">
        {{ $t('pages.useCases.subtitle_tools_use_cases') }}
      </h2>
      <p class="main-description">
        {{ $t('pages.useCases.desc_tools_use_cases') }}
      </p>
      <ul class="use-cases-list">
        <li
          v-for="useCase in useCases"
          :key="useCase.title"
          class="use-case-item"
        >
          <UseCaseCard
            :title="useCase.title"
            :description="useCase.description"
            look="row blue-dark"
          >
            <div slot="image" class="wrapper-icon-use-case">
              <img
                :src="img(useCase.image.url)"
                :alt="useCase.image.alt"
                loading="lazy"
                class="icon-use-case"
              />
            </div>
          </UseCaseCard>
        </li>
      </ul>
      <div class="entry-carousel">
        <Carousel>
          <Slide v-for="slide in useCasesSlider" :key="slide.description">
            <div class="carousel__item">
              <div class="wrapper-legend">
                <span class="legend">{{ slide.description }}</span>
              </div>
              <img
                :src="img(slide.image.url)"
                :alt="slide.image.alt"
                class="carousel-item-img"
              />
            </div>
          </Slide>

          <template #addons>
            <Navigation />
            <Pagination />
          </template>
        </Carousel>
      </div>
    </section>
  </main>
</template>

<script setup lang="ts">
import { useI18n } from 'vue-i18n'
import { computed } from 'vue'
import UseCaseCard from '@/components/UseCasesCard.vue'
import type { Image } from '@/interfaces/index'
import { Carousel, Navigation, Pagination, Slide } from 'vue3-carousel'
import '../../node_modules/vue3-carousel/dist/carousel.css'
import { img } from '../utils/image'

const { t } = useI18n()
const useCasesSlider = computed((): UseCaseSlider[] => [
  {
    description: t('pages.useCases.useCase_img_roadsigns.description'),
    image: {
      url: 'road-signs.png',
      alt: t('pages.useCases.useCase_img_roadsigns.image.alt')
    }
  },
  {
    description: t('pages.useCases.useCase_img_cartesapp.description'),
    image: {
      url: 'carte-app.png',
      alt: t('pages.useCases.useCase_img_cartesapp.image.alt')
    }
  },
  {
    description: t('pages.useCases.useCase_img_rivers.description'),
    image: {
      url: 'river-view.png',
      alt: t('pages.useCases.useCase_img_rivers.image.alt')
    }
  }
])
const useCases = computed((): UseCaseData[] => [
  {
    title: t('pages.useCases.useCase_roadsigns.title'),
    description: t('pages.useCases.useCase_roadsigns.description'),
    image: {
      url: 'panneaux-routiers-icon.svg',
      alt: t('pages.useCases.useCase_roadsigns.image.alt')
    }
  },
  {
    title: t('pages.useCases.useCase_api.title'),
    description: t('pages.useCases.useCase_api.description'),
    image: {
      url: 'api-white.svg',
      alt: t('pages.useCases.useCase_api.image.alt')
    }
  },
  {
    title: t('pages.useCases.useCase_rivers.title'),
    description: t('pages.useCases.useCase_rivers.description'),
    image: {
      url: 'river.svg',
      alt: t('pages.useCases.useCase_rivers.image.alt')
    }
  }
])
const useCasesArticles = computed((): UseCaseData[] => [
  {
    id: 'au-final-panoramax-ca-sert-a-quoi',
    title: t('pages.useCases.useCasesArticles_panoramax.title'),
    description: t('pages.useCases.useCasesArticles_panoramax.description'),
    image: {
      url: 'panoramax-article.jpg',
      alt: t('pages.useCases.useCasesArticles_panoramax.image.alt')
    }
  },
  {
    id: 'l-agglomeration-de-valparisis-pionniere-sur-panoramax',
    title: t('pages.useCases.useCasesArticles_valparisis.title'),
    description: t('pages.useCases.useCasesArticles_valparisis.description'),
    image: {
      url: 'valparisis-article.jpg',
      alt: t('pages.useCases.useCasesArticles_valparisis.image.alt')
    }
  },
  {
    id: 'cartes-app-1ere-carte-generaliste-a-integrer-panormax',
    title: t('pages.useCases.useCasesArticles_cartesapp.title'),
    description: t('pages.useCases.useCasesArticles_cartesapp.description'),
    image: {
      url: 'cartes-app-article.jpg',
      alt: t('pages.useCases.useCasesArticles_cartesapp.image.alt')
    }
  },
  {
    id: 'bayonne-un-reseau-d-agents-impliques-sur-la-collecte-pour-des-usages-multiples',
    title: t('pages.useCases.useCasesArticles_bayonnegeneric.title'),
    description: t(
      'pages.useCases.useCasesArticles_bayonnegeneric.description'
    ),
    image: {
      url: 'bayonne-general-article.jpg',
      alt: t('pages.useCases.useCasesArticles_bayonnegeneric.image.alt')
    }
  }
])
interface UseCaseData {
  id?: string
  title: string
  description: string
  image: Image
}
interface UseCaseSlider {
  description: string
  image: Image
}
</script>

<style scoped lang="scss">
.section {
  padding: 3rem 15%;
}
.section:nth-child(even) {
  background-color: var(--white);
}
.section:nth-child(odd) {
  background-color: var(--grey);
}
.use-cases-section-title {
  @include title();
  margin-bottom: 2rem;
}
.use-cases-list {
  display: flex;
  flex-wrap: wrap;
}
.use-case-item {
  flex: calc(33% - 2rem);
}
.use-case-article-item {
  flex: calc(50% - 2rem);
  cursor: pointer;
  margin-bottom: 4rem;
  &:nth-child(3),
  &:nth-child(4) {
    margin-bottom: 2rem;
  }
  &:nth-child(1),
  &:nth-child(3) {
    margin-right: 2rem;
  }
  .icon-use-case {
    width: 100%;
    border-radius: 2rem;
  }
  &:hover {
    .icon-use-case {
      transition: all 0.2s ease-out;
      transform: scale(1.05);
    }
  }
}
.wrapper-icon-use-case {
  border: 0.3rem solid var(--blue-dark);
  border-radius: 2rem;
  padding: 1rem;
  margin-right: 1rem;
  height: 8rem;
  width: fit-content;
  margin-bottom: 2rem;
}
.wrapper-icon-article-use-case {
  height: 30rem;
  margin-bottom: 2rem;
  overflow: hidden;
  border-radius: 2rem;
}
.article-link {
  text-decoration: none;
}
.use-case-item:nth-child(2n) {
  margin-right: 2rem;
  margin-left: 2rem;
}
.icon-use-case {
  height: 100%;
  width: initial;
  object-fit: cover;
  transition: all 0.2s ease-out;
}
.main-description {
  font-size: 1.6rem;
  color: var(--grey-dark);
  white-space: pre-line;
  margin-bottom: 2rem;
}
.img-use-cases {
  width: 100%;
  border-radius: 3rem;
}
.entry-carousel {
  padding: 2rem 6rem;
}
.wrapper-legend {
  padding: 0.5rem;
  position: absolute;
  top: 1rem;
  left: 1rem;
  background-color: var(--blue-dark);
  border-radius: 0.5rem;
  z-index: 1;
  display: flex;
  align-items: center;
  justify-content: center;
}
.legend {
  font-size: 1.2rem;
  color: var(--white);
}
.carousel-item-img {
  height: 100%;
  width: 100%;
  object-fit: contain;
  border-radius: 2rem;
}
@media (max-width: 1324px) {
  .section {
    padding: 3rem 10%;
  }
}
@media (max-width: 768px) {
  .section {
    padding: 2rem;
  }
  .use-cases-list {
    flex-direction: column;
  }
  .use-case-item {
    flex: calc(50% - 2rem);
    margin-top: 2rem;
  }
  .use-case-item:nth-child(odd) {
    margin-right: 2rem;
  }
  .use-case-item:nth-child(2) {
    margin-right: 0;
    margin-left: 0;
  }
  .use-case-article-item {
    margin-top: 0;
    &:nth-child(1),
    &:nth-child(3) {
      margin-right: 0;
    }
  }
}
@media (max-width: 500px) {
  .legend {
    font-size: 1rem;
  }
  .entry-carousel {
    padding: 1rem;
  }
  .carousel__prev {
    left: -4rem;
  }
  .carousel__next {
    right: -4rem;
  }
  .use-cases-section-title {
    font-size: 2rem;
    margin-bottom: 2rem;
  }
  .main-description {
    font-size: 1.4rem;
  }
  .use-case-item {
    flex: 100%;
  }
  .wrapper-icon-use-case {
    margin-right: 0;
    margin-bottom: 2rem;
    width: fit-content;
  }
}
</style>
<style>
.carousel__item {
  width: 100%;
  background-color: var(--blue-semi-ligth);
  border-radius: 2rem;
  display: flex;
  justify-content: center;
  position: relative;
}
.carousel__prev {
  left: -6rem;
}
.carousel__next {
  right: -6rem;
}
.carousel__next,
.carousel__prev {
  background-color: var(--blue);
  color: var(--white);
  border-radius: 50%;
  box-shadow: rgba(0, 0, 0, 0.15) 1.95px 1.95px 2.6px;
}
.carousel__next:hover,
.carousel__prev:hover {
  color: var(--white);
  opacity: 0.8;
}

@media (max-width: 500px) {
  .carousel__prev {
    left: -4rem;
  }
  .carousel__next {
    right: -4rem;
  }
}
</style>
